486 Predict the Winner
486. Predict the Winner
1. Question
Given an array of scores that are non-negative integers. Player 1 picks one of the numbers from either end of the array followed by the player 2 and then player 1 and so on. Each time a player picks a number, that number will not be available for the next player. This continues until all the scores have been chosen. The player with the maximum score wins.
Given an array of scores, predict whether player 1 is the winner. You can assume each player plays to maximize his score.
Example 1:
Example 2:
Note:
1 <= length of the array <= 20.
Any scores in the given array are non-negative integers and will not exceed 10,000,000.
If the scores of both players are equal, then player 1 is still the winner.
2. Implementation
(1) DP
思路: 这题只要我们求出第一个玩家是否能赢,定义dp数组dp[i][j]为在[i,j]的区间里,第一个玩家比第二个玩家多多少分,显然如果dp[0[n - 1] >= 0时,第一个玩家能赢。注意,Leetcode有个testcase [0],这个情况下应该返回true,所以dp[0][n - 1]等于0时也算第一个玩家赢。状态转移方程为dp[start][end] = Math.max(nums[start] - dp[start + 1][end], nums[end] - dp[start][end - 1])。 等start等于end时,dp[start][end] = nums[start]
3. Time & Space Complexity
DP: 时间复杂度O(n ^ 2), 空间复杂度O(n ^ 2)
Last updated
Was this helpful?